/*===========================================================================*/
/*
 * This file is part of
 * libalinga-java - the java bindings for
 * libalinga - a C++ library for Alligned Linguistic Annotation
 *
 * Copyright (C) 2007, 2008 Elaine Tsiang YueLien
 * libogg++java is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, see http://www.gnu.org/licenses/,
 * or write to the
 * Free Software Foundation, Inc.
 * 51 Franklin Street, Fifth Floor
 * Boston, MA  02110-1301, USA
 *
 *===========================================================================*/
/** @file JniALingA.i                                                        *
 *                                                                           *
 *  swig conversion specification for ALingA                                 *
 *                                                                           */
/*===========================================================================*/
%module(directors="1") JniALingA
%{
#include <ALingA/ALingA.H>
#include <ALingA/Encode.H>
#include <ALingA/LingA.H>
#include <ALingA/Manifold.H>
#include <ALingA/Metas.H>
#include <ALingA/NodesArcs.H>
#include <ALingA/Signal.H>
%}

%include <std_string.i>
%include <glib_ustring.i>

%include <arrays_java.i>
%apply signed char[] {signed char *};
%rename("assign") operator =;

//%typemap(javafinalize) SWIGTYPE "" 

SWIG_JAVABODY_METHODS(public, public, ALingA::Encode, ALingA::Manifold, ALingA::Metas, std::map<Glib::ustring, Glib::ustring>, ALingA::Signal)

%include <Encode.i>
%include <std_map.i>

%typemap(javafinalize) ALingA::Metas, ALingA::Metas *, ALingA::Metas & "" 
%include <Metas.i>

%exception %{
try {
     $action
     } catch (Ogg::Exception & e)
      {
        jclass excep = jenv->FindClass("java/lang/Exception");
	if (excep)
	 jenv->ThrowNew(excep, e.what());
  	return $null;
	}
       catch (...)
      {
        SWIG_JavaThrowException(jenv, SWIG_JavaRuntimeException,
        			"C++ non Ogg::Exception thrown");
  	return $null;
	}
%}

%typemap(javafinalize) ALingA::Manifold, ALingA::Manifold *, ALingA::Manifold & "" 
%include <Manifold.i>
%typemap(javafinalize) ALingA::Signal, ALingA::Signal *, ALingA::Signal & "" 
%include <Signal.i>

%include <NodesArcs.i>

%import <JniOgg.i>
%typemap("javapackage") Ogg::Page, Ogg::Page *, Ogg::Page & "org.gnutopia.ogg";
%typemap (javaimports) ALingA::LingA, ALingA::ALingA, ALingA::ALingAMuxer %{
import org.gnutopia.ogg.*;
%} 
%pragma(java) moduleimports="import org.gnutopia.ogg.*;"
%pragma(java) jniclassimports="import org.gnutopia.ogg.*;"
%typemap(javafinalize) ALingA::LingA, ALingA::LingA *, ALingA::LingA & "" 
%include <LingA.i>
%typemap(javafinalize) ALingA::ALingA, ALingA::ALingA *, ALingA::ALingA & "" 
%typemap(javafinalize) ALingA::ALingAMuxer, ALingA::ALingAMuxer *, ALingA::ALingAMuxer & "" 
%include <ALingA.i>

