/*===========================================================================*/
/*
 * This file is part of
 * libalinga-java - the java bindings for
 * libalinga - a C++ library for Alligned Linguistic Annotation
 *
 * Copyright (C) 2007, 2008 Elaine Tsiang YueLien
 * libogg++java is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, see http://www.gnu.org/licenses/,
 * or write to the
 * Free Software Foundation, Inc.
 * 51 Franklin Street, Fifth Floor
 * Boston, MA  02110-1301, USA
 *
 *===========================================================================*/
%rename("less") operator <;
%rename("eq") operator ==;

// The java side is given deletion rights
// to Arc and Node instances returned by first and next.
// However, the java side may not garbage collect them.
// The java side should delete them explicitly
// The temp Arcs and Nodes delivered to the java side
// are allowed to be subject to java garbage collection
// because the jni code makes copies, so there will be garbage to collect.
// %typemap(javafinalize) ALingA::Nodes, ALingA::Nodes *, ALingA::Nodes & ""
// %typemap(javafinalize) ALingA::Arcs, ALingA::Arcs *, ALingA::Arcs & "" 
%newobject ALingA::Arcs::first;
%newobject ALingA::Arcs::next;
%include <Cni/Arcs.H>
%newobject ALingA::Nodes::first;
%newobject ALingA::Nodes::next;
%include <Cni/Nodes.H>

%typemap(javafinalize) ALingA::Node, ALingA::Node *, ALingA::Node & ""
%typemap(javafinalize) ALingA::Arc, ALingA::Arc *, ALingA::Arc & "" 
%include <Cni/NodesArcs.H>

